package com.realnet.order_estimation.Controllers;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
 import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import com.fasterxml.jackson.core.JsonProcessingException;
import org.springframework.web.bind.annotation.CrossOrigin;
import com.fasterxml.jackson.databind.JsonMappingException;
import com.realnet.config.EmailService;
import com.realnet.users.entity1.AppUser;
import com.realnet.users.service1.AppUserServiceImpl;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.springframework.data.domain.*;
import com.realnet.fnd.response.EntityResponse;
import org.springframework.http.*;
import org.springframework.beans.factory.annotation.*;
import com.realnet.order_estimation.Entity.Product;
import com.realnet.order_estimation.Services.ProductService ;








@RequestMapping(value = "/token/Product")
 @CrossOrigin("*") 
@RestController
public class tokenFree_ProductController {
	@Autowired
	private ProductService Service;

@Value("${projectPath}")
	private String projectPath;
 








	@PostMapping("/Product")
		  public Product Savedata(@RequestBody Product data) {
		Product save = Service.Savedata(data)	;







		System.out.println("data saved..." + save);

 return save;
	  }
@PutMapping("/Product/{id}")
	public  Product update(@RequestBody Product data,@PathVariable Integer id ) {
		Product update = Service.update(data,id);
		System.out.println("data update..." + update);
		return update;
	}	 
//	get all with pagination
	@GetMapping("/Product/getall/page")
	public Page<Product> getall(@RequestParam(value = "page", required = false) Integer page,
			@RequestParam(value = "size", required = false) Integer size) {
		Pageable paging = PageRequest.of(page, size);
		Page<Product> get = Service.getAllWithPagination(paging);

		return get;

	}	
	@GetMapping("/Product")
	public List<Product> getdetails() {
		 List<Product> get = Service.getdetails();		
		return get;
}
// get all without authentication 

	@GetMapping("/token/Product")
	public List<Product> getallwioutsec() {
		 List<Product> get = Service.getdetails();		
		return get;
}
@GetMapping("/Product/{id}")
	public  Product  getdetailsbyId(@PathVariable Integer id ) {
		Product  get = Service.getdetailsbyId(id);
		return get;
	}
@DeleteMapping("/Product/{id}")
	public  ResponseEntity<?> delete_by_id(@PathVariable Integer id ) {
	Service.delete_by_id(id);
			return new ResponseEntity<>(new EntityResponse("Deleted"), HttpStatus.OK);
	
	}









}